# signature { license=0, seed=277031123, key="fb0823a0e960e685a4c88c9bef2b4da9" }























require 'paths' 'oauth'
cgi = require( 'cgi' )

config = require( 'config' )

i18nTexts = config.read( 'i18n.txt' ).i18n








function i18n( key, default) return i18nTexts[ key ] or default or key end

cfg = config()









local function auth()
	local socket = require( 'socket' )
	local tls = false
	local port = require( 'xmlpro.core' ).port
	if port == 0 then

		tls, port = cgi.socket:getsockname()
	end

	local text = '<get><mb mb="9002"><k k="2">[1-2]</k></mb></get>'
	local request = 'POST /dbms.xml HTTP/1.1\r\nAuthorization: %s\r\nContent-Length: %d\r\n\r\n%s'
	local s = socket.connect( '127.0.0.1', port )
	if tls then

		local ok, err
		s, err = require( 'ssl' ).wrap( s, { protocol='tlsv1_2', mode='client', verify='none' } )
		if not s then error(err) end
		ok, err = s:dohandshake()
		if not ok then return nil, err end
	end

	s:send( request:format( cgi.AUTHORIZATION or '', #text, text ) )

	local response = ''
	local status = s:receive():match( ' (%d%d%d)' )
	if status == '200' then
		local len = 0

		repeat
			local line = s:receive()
			len = line:lower():match( '^content%-length:%s*(%d+)' ) or len
		until line == ''

		response = s:receive( tonumber( len)  or 0 )
	end
	s:close()

	return response, status
end


if not string.find( auth(), 'i=' ) then
	cgi.status = "401 Unauthorized"
	cgi.header( 'WWW-Authenticate', 'Basic realm="InOAuth Configuration"' )
	cgi.print( "Unauthorised!" )
	return
end







function receiveFile( filename, maxLength )
	local enctype, boundary = string.match( (cgi.CONTENT_TYPE or ''), '%s*([^;]+);%s*boundary=(.*)$' )
	local length = tonumber( cgi.CONTENT_LENGTH or 0 )

	if enctype ~= 'multipart/form-data' then return nil, "wrong encoding type" end
	if length <=0 then return nil, 'no content' end
	if maxLength and length > maxLength then

		while length > 4096 do
			cgi.receive( 4096 )
			length = length - 4096
		end

		if length >0 then
			cgi.receive( length )
		end

		return nil, "too large"
	end

	if filename then

		length = length - #boundary - 8

		local posted = cgi.receive( math.min( 4096, length ) )
		length = length - #posted
		print("receiving "..length.."bytes")

		local a =  posted:find( '\r\n\r\n' )

		posted = posted:sub( a + 4 )
		local f = io.open( filename, "w" )
		if f then

			f:write( posted )


			while length > 4096 do
				posted = cgi.receive( 4096 )
				f:write( posted )
				length = length - 4096
			end

			if length > 0 then
				posted = cgi.receive( length )
				f:write( posted )
			end

			f:close()
		else
			return nil, "cannot write to file"
		end
		return true
	else
		if length > 500000 then return nil, "too large" end
		local posted = cgi.receive( length )
		boundary = string.gsub( boundary, '[][().%+-*?^$]', '%%%1')
		posted = string.match( posted, boundary..'.-\r\n\r\n(.-)\r\n%-%-'..boundary)

		return posted
	end
end




local function setFlag( name )
	local f = io.open( name, 'w' )
	if f then
		f:close()
	end
end


MsgBox = ''
posted = ''







local function switch( name )

	local code = loadfile( name .. '.cfg', 't', cfg )
	if code then

		local ok = pcall( code )
		if ok then

			config.write( cfg )
			setFlag( 'loadconfig' )
		end
	end
	return 'cfghome'
end




function urlencode( url )
	return url:gsub( '([^%w._~-])', function( c ) return ('%%%02X'):format( c:byte() ) end )
end

local internalCommands =
{

	getcfg = function()
		cgi.header( 'Content-Disposition', os.date( 'attachment; filename=inoauth-2.0.2-%Y%m%d-%H%M%S.cfg' ) );
		cgi.header( 'Content-Type','application/octet-stream');
		cgi.printf( '%s;\n', cfg:Lua() )
	end;


	puti18n = function()

		local posted = receiveFile()
		local split = posted:find( '\ni18n' )

		local e = {}
		local code,err = load( posted, 'language file', 't', e )
		pcall( code )

		if not code then
			MsgBox = "the language text file can't be compiled, Lua says:\\n" .. (err:gsub( '"', '\\"' ) )
		elseif not e.i18n  then
			MsgBox = "the language text file does not contain translation texts"
		end

		if code and e.i18n and split and split > 0 then
			local f = io.open( 'i18n.txt', 'w' )
			if f then
				f:write( posted:sub( split ) )
				f:close()
			end
			i18nTexts = e.i18n
		end
		return 'cfghome'
	end;


	putcfg = function()
		local posted = receiveFile()
		local newcfg = config.change( { i18n=i18n }, posted )
		if newcfg then
			cfg = newcfg
			config.write( cfg )
			setFlag( 'loadconfig' )
		end
		return 'cfghome'
	end;


	o365 = function()
		return switch( 'o365' )
	end;


	gmail = function()
		return switch( 'gmail' )
	end;


	i18n = function()
		cgi.header( 'Content-Type','application/javascript') ;
		cgi.header( 'Cache-Control', 'max-age=3600' );
		cgi.print
		(
			[[var js18n = ]],
			cfg.JSON( i18nTexts ),
			[[;function i18n( key, def ){ return js18n[ key ] || def || key } ]]
		)
	end;




	authorized = function()
		local ok, refresh
		dump = function() end

		local code = cgi.GET.code
		if code then
			ok, refresh = require( 'oauth2' ).useAuthorizationCode( code )
		end


		if ok then
			if refresh then
				MsgBox = i18n("Authorization was successful")
			else
				MsgBox = i18n("Did not get a refresh token")
			end
		else
			MsgBox = i18n("Authorization failed")
		end

		return 'cfghome'
	end;
}


cgi.head =
[[
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<link rel="shortcut icon" href="favicon.ico" />
<link rel="stylesheet" type="text/css" href="../common.css" />
<link rel="stylesheet" type="text/css" href="oauth.css" />
]]









local function anchor( P, class )
	P.class = class
	local html ='<a'
	for k, v in pairs( P ) do
		if type( k ) == 'string' and k ~= 'img' then html = html .. ' ' .. k .. '="' .. v .. '"' end
	end
	html = html .. '>'
	if P.img then html = html .. '<img alt="" src="' .. P.img .. '" />' end
	if P[ 1 ]  then html = html .. P[ 1 ] end
	html = html .. '</a>'
	return html
end



cgi.button = function( P ) return anchor( P ,'button' ) end



cgi.icon   = function( P ) return anchor( P, 'icon' ) end


cgi.h1 = '<h1>InOAuth <small>2.0.2</small></h1>'




cgi.GET = cgi.urldecode( cgi.QUERY_STRING )


local command = cgi.GET.cmd or 'cfghome'







local function snip( text, name )

	text = text:gsub( '^.-[?&]' .. name .. '=', '' )

	text = text:gsub( '&.*', '' )



	text = text:gsub( '^.-=', '' )

	return text
end

if cgi.REQUEST_METHOD == 'POST' then
	local length = tonumber( cgi.CONTENT_LENGTH or 0 )

	if length > 0 then
		local enctype = string.match( (cgi.CONTENT_TYPE or ''), '%s*([^;]+);%s*boundary=(.*)$' )
		if enctype ~= 'multipart/form-data' then
			if length > 500000 then
				MsgBox = i18n("Uploaded data too large") .. '\\n'
			else
				posted = cgi.receive( length )

				CGI.POST = cgi.urldecode( posted )
				command = CGI.POST.cmd or command

				if CGI.POST.change then
					cfg = cfg:change( CGI.POST.change )



					local code = cfg.ActivationCode or ''
					if code > '' then

						local state = snip( code, 'state' )
						if tostring( cfg.State ) == state then
							cgi.GET.code = snip( code, 'code' )
							command = 'authorized'
						end
					end

					cfg.ActivationCode = ''

					cfg:write()
					setFlag( 'loadconfig'  )
				end
			end
		end
	end
end

while command do

	local f = internalCommands[ command ]
	if not f then

		command = command  .. '.lua'

		if not os.license( command ) then break end

		f = loadfile( command )
	end

	if not f then break end


	command = f()
end
